/*
 *
 * control panel applet for idea.
 *
 */

#include <hildon-cp-plugin/hildon-cp-plugin-interface.h>
#include <hildon-widgets/hildon-program.h>
#include <hildon-widgets/hildon-file-chooser-dialog.h>
#include <hildon-widgets/hildon-font-selection-dialog.h>
#include <libosso.h>
#include <stdio.h>
#include <dirent.h>
#include <string.h>
#include <gtk/gtk.h>

#include "libidea.h"


static GtkWidget *size_icon_combo;
static GtkWidget *tot_icon_spin;
static GtkWidget *spin1;
static GtkWidget *spin2;
static GtkWidget *spin3;
static GtkWidget *button[MAX_ICON];
static GtkWidget *ientry[MAX_ICON];
static GtkWidget *ivbox[MAX_ICON];
static GtkWidget *icon_hbox;
static GtkWidget *swindow;
static GtkWidget *private_table;
static gint icon_size = 48; /*by default */
static GdkPixbuf *icon[MAX_ICON];
static GtkWidget *icon_image[MAX_ICON];
static gchar *icon_buff[MAX_ICON];
static GtkWidget *chdialog;
static gchar *font_size[] = { "xx-small", "x-small", "small", "medium", "large","x-large","xx-large",NULL }; 
static GtkWidget *bcheck;
static GtkWidget *icheck;
static GtkWidget *ccbox;
static GtkWidget *buttonC;
static GtkWidget *vbutt;
static GtkWidget *the_icon_box;

static GtkTreeModel *model;
static GtkWidget *treeview; //TreeView *treeview;
static GtkCellRenderer *renderer;
static GtkTreeViewColumn *column;
static GtkWidget *sw;
static GtkWidget *table;

static gboolean smtg_written = FALSE;

static gint save_row;
static gchar *save_label[MAX_ICON];
static gchar *save_img[MAX_ICON];

static gboolean icon_url(GtkWidget *widget, int i);
void parseDoc(char *docname);
GtkWidget*  hildon_color_button_new_with_color (const GdkColor *color);
static gboolean refresh_value();
static gboolean choose_app(int flag);
static gboolean update_size();


enum
{
	COL_POS,
	COL_ICON,
	COL_PROG,
	COL_DEFAULT_ICON,
	NUM_COLS
};

static GtkTreeModel *
create_model (void)
{
	gint i = 0;
	GtkListStore *store;
	GtkTreeIter iter;
	
	store = gtk_list_store_new(NUM_COLS,
				   G_TYPE_INT,
				   G_TYPE_STRING,
				   G_TYPE_STRING,
				   G_TYPE_BOOLEAN);
	for(i=0;i<ticon;i++) {
		gtk_list_store_append(store,&iter);
		gtk_list_store_set(store,&iter, COL_POS, i, COL_ICON, iname[i], COL_PROG, app[i], COL_DEFAULT_ICON, FALSE, -1);
	}
	return GTK_TREE_MODEL(store);
}

static gboolean
build_d_button()
{
	gint i;
	guint val;
	GtkWidget *label;
	const gchar *path;
	gint tot_rows = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(tot_icon_spin)) / i_rows;
	int oldchekpoint = 0;
	int checkpoint = i_rows;
	int y=0;

	update_size();
	val = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(tot_icon_spin));
	if ( GTK_IS_WIDGET(swindow) ) { 
		gtk_widget_destroy(GTK_WIDGET(swindow)); 
	}
	if ( GTK_IS_WIDGET(icon_hbox) ) { 
		gtk_widget_destroy(GTK_WIDGET(icon_hbox)); 
	}
	
	if ( (tot_rows%i_rows) != 0 ) tot_rows++;
	icon_hbox = gtk_vbox_new(FALSE,val);
	private_table = gtk_table_new(val+1,val+1,FALSE);
	
	for(i=0;i<tot_rows;i++)
	{
		for(;y<checkpoint&&y<val;y++) {
			ivbox[y] = gtk_vbox_new(FALSE,val);
			ientry[y] = gtk_entry_new();
			button[y] = gtk_button_new();
			if ( nname[y] != NULL ) {
				if ( !found_it("/",nname[y]) ) {
					path = get_icon_path_from_name(nname[y],size);
					icon[y] = gdk_pixbuf_new_from_file_at_size(path,size,size,NULL);
					g_free(path); /*experimental*/
				} else {
					icon[y] = gdk_pixbuf_new_from_file_at_size(nname[y],size,size,NULL);
				}
				if ( icon[y] != NULL ) {
					icon_image[y] = gtk_image_new_from_pixbuf(icon[y]);
					gtk_container_add(GTK_CONTAINER(button[y]), icon_image[y]);
				} else {
					/*nop*/
				}
			} else {
				label = gtk_label_new(NULL);
				gtk_label_set_markup(GTK_LABEL(label), "<span size=\"xx-small\" weight=\"bold\">Click to\nset icon</span>");
				gtk_container_add(GTK_CONTAINER(button[y]), label);
			}
			if ( iname[y] != NULL ) {
				gtk_entry_set_text(GTK_ENTRY(ientry[y]),iname[y]);
			}
		
			gtk_widget_set_usize(GTK_WIDGET(button[y]),65,65);
			gtk_widget_set_usize(GTK_WIDGET(ientry[y]),65,30);
			/* on click load icon!*/
			g_signal_connect(button[y], "clicked", G_CALLBACK(icon_url), (gpointer) y);
			gtk_box_pack_start(GTK_BOX(ivbox[y]), button[y], FALSE, FALSE, 0);
			gtk_box_pack_start(GTK_BOX(ivbox[y]), ientry[y], FALSE, FALSE, 0);
			gtk_table_attach_defaults(GTK_TABLE(private_table), ivbox[y], y - oldchekpoint,y - oldchekpoint +1,i,i+1);
		}
		oldchekpoint = checkpoint;
		checkpoint=checkpoint + i_rows;
	}
	gtk_box_pack_start(GTK_BOX(icon_hbox), private_table, FALSE,FALSE, 0);
	
	swindow = gtk_scrolled_window_new(NULL,NULL);
	
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(swindow), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(swindow), icon_hbox);
	gtk_widget_show_all(GTK_WIDGET(swindow));
	
	gtk_box_pack_start(GTK_BOX(the_icon_box), swindow, TRUE,TRUE,0);
	
	return TRUE;
}


static gboolean
icon_url(GtkWidget *widget, int i)
{
	GtkWidget *dialog;
	gchar *filename = NULL;
			
	dialog = hildon_file_chooser_dialog_new (GTK_WINDOW (widget), GTK_FILE_CHOOSER_ACTION_OPEN);
	gtk_widget_show_all (GTK_WIDGET (dialog));
	
	if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_OK) {
		filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));
		if ( filename != NULL ) {
			if ( nname[i] == NULL ) {
				nname[i] = g_strdup(filename);
				g_free(filename);
				choose_app(i);
			} else {
				nname[i] = g_strdup(filename);
				g_free(filename);
			}
		}
	}

	build_d_button();
	gtk_widget_destroy(dialog);

	return TRUE;
}

static gboolean
update_label()
{
	gint i;
	for(i=0;i<gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(tot_icon_spin));i++) {
		if ( ientry[i] != NULL ) {
			if ( gtk_entry_get_text(GTK_ENTRY(ientry[i])) != NULL ) {
				iname[i] = g_strdup(gtk_entry_get_text(GTK_ENTRY(ientry[i])));
			}
		}
	}
	return TRUE;
}

static gboolean
update_size()
{
	switch ( gtk_combo_box_get_active(GTK_COMBO_BOX(size_icon_combo)) ) {
		case 0 : icon_size = 16;
			 break;
		case 1 : icon_size = 24;
			 break;
		case 2 : icon_size = 32;
			 break;
		case 3 : icon_size = 48;
			 break;
		case 4 : icon_size = 64;
			 break;
		default : icon_size = 48;
			break;
	}
	size = icon_size;
	return TRUE;
}

static gboolean 
preloader_choose_app(GtkWidget *widget)
{
	choose_app(0);
	return TRUE;
}

static gboolean
choose_app(int flag)
{
	GtkWidget *dialog;
	GtkTreeModel *model;
	GtkTreeSelection *selection;
	GList *list,*node;
	GtkWidget *hbox;
	GtkWidget *label;
	GtkWidget *label0;
	GtkWidget *label1;
	GtkWidget *v_box;
	GtkWidget *combo;
	GtkWidget *check0;
	gint response;
	GDir *d;

	gchar composed_string[4096];
	gchar save_l[64];
	gchar save_p[255];
	gint savepos;
	gboolean save_def_icon;

	if ( flag != 0 ) {
		char *str1;
		char *saveit;
		const gchar *work_on_it;

		work_on_it = g_strdup(nname[flag]);

		str1 = strtok(work_on_it,"/");
		while(1) {
			str1 = strtok(NULL,"/");
			if ( str1 == NULL ) break;

			saveit = str1;
		}
		g_snprintf(composed_string,4096,"Choose the application to associate to the icon <b>%s</b>",saveit);
		savepos = flag;
		save_def_icon = FALSE;
		g_snprintf(save_p,255,"null",NULL);
	} else {
	
	model = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));
	
	selection = gtk_tree_view_get_selection (GTK_TREE_VIEW(treeview));
	list = gtk_tree_selection_get_selected_rows(selection,&model);
	for (node = list; node; node = g_list_next(node)) 
	{
		gint *pos;
		gchar *i,*p;
		gboolean *def_icon;
		GtkTreeIter iter;
		GtkTreePath *path = node->data;
		gtk_tree_model_get_iter(model, &iter, path);
		gtk_tree_model_get(model,
				   &iter, 
				   0, &pos,
				   1, &i,
				   2, &p,
				   3, &def_icon,
				   -1);
		if ( i != NULL ) {
			g_snprintf(save_l,64,"%s",i);
			g_snprintf(composed_string,4096,"Choose the application to associate to the icon <b>%s</b>",i);
			g_snprintf(save_p,255,"%s",p);
			savepos = pos;
			save_def_icon = def_icon;
		}
		g_free(i);
		g_free(p);
		gtk_tree_path_free(path);
	}
	
	g_list_free(list);
	g_list_free(node);
	}
	dialog = gtk_dialog_new();
	gtk_dialog_add_buttons(GTK_DIALOG(dialog),
				GTK_STOCK_OK,
				GTK_RESPONSE_OK,
				GTK_STOCK_CANCEL,
				GTK_RESPONSE_CANCEL,
				NULL);
	gtk_window_set_title(GTK_WINDOW(dialog), "Icon Association");
	v_box = gtk_vbox_new(TRUE,5);
	hbox = gtk_hbox_new(TRUE,2);
	label = gtk_label_new(NULL);
	gtk_label_set_markup(GTK_LABEL(label),composed_string);
	
	gtk_box_pack_start(GTK_BOX(hbox), label, TRUE,TRUE, 0);
	gtk_box_pack_start(GTK_BOX(v_box), hbox, TRUE,TRUE, 0);
	
	hbox = gtk_hbox_new(TRUE,3);
	label = gtk_label_new("Number");
	label0 = gtk_label_new("Program Name");
	gtk_box_pack_start(GTK_BOX(hbox), label, TRUE,TRUE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), label0, TRUE,TRUE, 0);
	if ( flag == 0 ) {
		label1 = gtk_label_new("Use default Icon");
		gtk_box_pack_start(GTK_BOX(hbox), label1, TRUE,TRUE, 0);
	}
	gtk_box_pack_start(GTK_BOX(v_box), hbox, TRUE,TRUE, 0);
	
	hbox = gtk_hbox_new(TRUE,5);
	
	char tmp[64];
	g_snprintf(tmp,64,"<b>%d</b>",savepos);
	label = gtk_label_new(NULL);
	gtk_label_set_markup(GTK_LABEL(label),tmp);
	
	combo = gtk_combo_box_new_text();
	gtk_combo_box_append_text(GTK_COMBO_BOX(combo),save_p);
	gtk_combo_box_set_active(GTK_COMBO_BOX(combo),0);
	d = g_dir_open("/usr/share/applications/hildon/",0,NULL);
	if ( d ) {
		const gchar *file;
		while (( file = g_dir_read_name(d)) ) {
			char *str;
			str = strtok((char *)file,".");
			gtk_combo_box_append_text(GTK_COMBO_BOX(combo),str);
		}
	}
	
	gtk_box_pack_start(GTK_BOX(hbox), label, TRUE,TRUE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), combo, TRUE,TRUE, 0);
	if ( flag == 0 ) {
		check0 = gtk_check_button_new ();
		if ( save_def_icon ) {
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check0), TRUE);
		}
		gtk_box_pack_start(GTK_BOX(hbox), check0, FALSE,FALSE, 0);
	}
	gtk_box_pack_start(GTK_BOX(v_box), hbox, TRUE,TRUE, 0);
	
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox), v_box);
	
	gtk_widget_show_all(GTK_WIDGET(dialog));
	response = gtk_dialog_run(GTK_DIALOG(dialog));
	if ( response == GTK_RESPONSE_OK ) {
		if ( flag != 0 ) {
			app[savepos] = gtk_combo_box_get_active_text(GTK_COMBO_BOX(combo));
		} else {
		app[savepos] = gtk_combo_box_get_active_text(GTK_COMBO_BOX(combo));
		if ( gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(check0)) ) {
			gchar file_tmp[128];
			gchar ic[64];
			char read_buffer[4096];
			g_snprintf(file_tmp,128,"/usr/share/applications/hildon/%s.desktop",gtk_combo_box_get_active_text(GTK_COMBO_BOX(combo)));

			FILE *fi = fopen(file_tmp,"r");
			while(fgets(read_buffer,4096,fi) != NULL ) {
					if ( strncmp(read_buffer,"Icon=", 5) == 0 ) {
						g_snprintf(ic,sizeof(ic),"%s",read_buffer + 5);
					}
			}
			fclose(fi);
			gboolean res;
			char *c;
			c = strstr(ic,"\n");
			while (c != NULL ) {
				c[0] = ' ';
				c = strstr(++c,"\n");
			}
			const gchar *the_icon;
			the_icon = g_strchomp(ic);
			res = gtk_icon_theme_has_icon(gtk_icon_theme_new(),the_icon);
			if ( res ) {
				nname[savepos] = g_strdup(the_icon);
			} else {
				/* if not, wath to do ? */
			}
		} else {
			/*do nothing ? 
			yeah, the better way :P
			*/
		}
		}
		XmlWriteInfo("/home/user/.idea/idea.xml",
				size,
				nname,  
				i_rows,
				ticon,
				color,
				iname,
				cell_spacing,
				row_spacing,
				weight,
				style,
				fsize,
				visible,
				app);
		smtg_written = TRUE;
		refresh_value(NULL);
	}
	gtk_widget_destroy(GTK_WIDGET(dialog));

	return TRUE;
}

static gboolean
save_icons_settings()
{
	/* save icons settings 
	* like , size,url,entry etc.. */
	update_size();
	update_label();
	ticon = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(tot_icon_spin));
		XmlWriteInfo("/home/user/.idea/idea.xml",
			size,
			nname,
			i_rows,
			ticon,
			color,
			iname,
			cell_spacing,
			row_spacing,
			weight,
			style,
			fsize,
			visible,
			app);
		smtg_written = TRUE;
	return TRUE;
}

static gboolean
save_table_settings()
{
	i_rows = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spin1));
	row_spacing = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spin2));
	cell_spacing = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spin3));
	/*5 8 9 13 */
	XmlWriteInfo("/home/user/.idea/idea.xml",
			size,
			nname,
			i_rows,
			ticon,
			color,
			iname,
			cell_spacing,
			row_spacing,//gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spin2)),
			weight,
			style,
			fsize,
			visible,
			app);
	smtg_written = TRUE;
	return TRUE;
	
}

static gboolean
save_label_settings()
{
	/* here we save 
	 * @bold,italic,color,size
	 *
	 */
	if ( gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(bcheck)) ) {
		weight = "bold";
	} else { 
		weight = "normal";
	}

	if ( gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(icheck)) ) {
		style = "italic";
	} else { 
		style = "normal";
	}

	if ( gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(vbutt)) ) {
		visible = 1;
	} else  { visible = 0; }

	if ( font_size[gtk_combo_box_get_active(GTK_COMBO_BOX(ccbox))] == NULL ) 
		fsize = "medium";
	else {
		fsize = font_size[gtk_combo_box_get_active(GTK_COMBO_BOX(ccbox))];
	}
	GdkColor *ncolor;
	gchar *color_ex;

	g_object_get( GTK_OBJECT(buttonC), "color", &ncolor );
	color_ex = g_strdup_printf("#%02x%02x%02x", ncolor->red >> 8, ncolor->green >> 8, ncolor->blue >> 8);
	color = g_strdup(color_ex);
	/*parsize it to xml */
	XmlWriteInfo("/home/user/.idea/idea.xml",
			size,
			nname,
			i_rows,
			ticon,
			color,
			iname,
			cell_spacing,
			row_spacing,
			weight,
			style,
			fsize,
			visible,
			app);
	smtg_written=TRUE;
	
	g_free(color_ex);

	return TRUE;
}

static gboolean
build_entry_list()
{
	sw = gtk_scrolled_window_new(NULL,NULL);
	gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (sw),
					   GTK_SHADOW_ETCHED_IN);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (sw),
				      GTK_POLICY_NEVER,
				      GTK_POLICY_AUTOMATIC);
	
	model = create_model();
	
	treeview = gtk_tree_view_new_with_model(model);
	gtk_tree_view_set_rules_hint(GTK_TREE_VIEW(treeview), TRUE);
	gtk_widget_set_usize(GTK_WIDGET(treeview), 480,100);
	
	g_object_unref(model);
	
	/**FIXME**/
	renderer = gtk_cell_renderer_text_new ();
	column = gtk_tree_view_column_new_with_attributes ("Icon Name",
						     renderer,
						     "text",
						     COL_ICON,
						     NULL);
	gtk_tree_view_column_set_sort_column_id (column,COL_ICON);
	gtk_tree_view_append_column (GTK_TREE_VIEW(treeview), column);

	/* column for pname */
	renderer = gtk_cell_renderer_text_new ();
	column = gtk_tree_view_column_new_with_attributes ("Program Name",
						     renderer,
						     "text",
						     COL_PROG,
						     NULL);
	gtk_tree_view_column_set_sort_column_id (column,COL_PROG);
	gtk_tree_view_append_column (GTK_TREE_VIEW(treeview), column);
	
	gtk_widget_show_all(GTK_WIDGET(treeview));

	g_signal_connect (treeview, "row-activated", G_CALLBACK (preloader_choose_app), NULL);
	
	gtk_container_add(GTK_CONTAINER(sw),treeview);
	
	gtk_widget_show_all(GTK_WIDGET(sw));

	gtk_table_attach_defaults(GTK_TABLE(table), sw, 0,1,1,2);

	return TRUE;
}

static gboolean
refresh_value()
{
	gtk_widget_destroy(GTK_WIDGET(treeview));
	parseDoc("/home/user/.idea/idea.xml");
	build_entry_list();
	
	return TRUE;
}

static gboolean
idea_cp_quit()
{
	GtkWidget *dialog;
	dialog = gtk_message_dialog_new(GTK_WINDOW(NULL), GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_INFO, GTK_BUTTONS_OK, "To make changes take effects,\nplease reload the home plugin.\n");
	gtk_dialog_run(GTK_DIALOG(dialog));
	gtk_widget_destroy(dialog);

	return TRUE;
}

osso_return_t execute(osso_context_t *osso,gpointer data, gboolean user_activated)
{
	GtkWidget *dialog;
	GtkWidget *mbox0;
	GtkWidget *label0;
	GtkWidget *ibox;
	GtkWidget *tbox;
	GtkWidget *lbox;
	GtkWidget *label1;
	GtkWidget *buttonS0;
	GtkWidget *buttonS1;
	GtkWidget *buttonS2;
	GtkWidget *notebook;
	GtkWidget *icon_frame;
	GtkWidget *table_frame;
	GtkWidget *app_frame;
	GtkWidget *label_frame;
	GtkWidget *mbox;
	GtkWidget *mbox2;
	GtkWidget *button0;
	gint resp;
	gint i;
	GtkWidget *isw;
	GtkWidget *iv;

	parseDoc("/home/user/.idea/idea.xml");

	
	dialog = gtk_dialog_new(); 
	
	gtk_window_set_title(GTK_WINDOW(dialog), "IDEA Customizing Applet");
	gtk_window_set_resizable (GTK_WINDOW (dialog), FALSE);
	gtk_widget_set_usize(GTK_WIDGET(dialog), 540,350);

	gtk_dialog_add_buttons(GTK_DIALOG(dialog),
				GTK_STOCK_QUIT, GTK_RESPONSE_CANCEL,
				NULL);
	
	notebook = gtk_notebook_new();
	icon_frame = gtk_frame_new("Icon Setting");
	table_frame = gtk_frame_new("Table Setting");
	app_frame = gtk_frame_new("Application Setting");
	label_frame = gtk_frame_new("Label Setting");
	
	mbox = gtk_vbox_new(FALSE,2);
	ibox = gtk_hbox_new(FALSE,2);
	label0 = gtk_label_new("ICON DIMENSION");
	size_icon_combo = gtk_combo_box_new_text();
	gtk_combo_box_append_text(GTK_COMBO_BOX(size_icon_combo),"16");
	gtk_combo_box_append_text(GTK_COMBO_BOX(size_icon_combo),"24");
	gtk_combo_box_append_text(GTK_COMBO_BOX(size_icon_combo),"32");
	gtk_combo_box_append_text(GTK_COMBO_BOX(size_icon_combo),"48");
	gtk_combo_box_append_text(GTK_COMBO_BOX(size_icon_combo),"64");
	char s[3];
	g_snprintf(s,3,"%d",size);
	gtk_combo_box_append_text(GTK_COMBO_BOX(size_icon_combo),s);
	gtk_combo_box_set_active(GTK_COMBO_BOX(size_icon_combo),5);
	//g_signal_connect(combo0, "changed", G_CALLBACK(update_size), NULL);
	gtk_box_pack_start(GTK_BOX(ibox), label0, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(ibox), size_icon_combo, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(mbox), ibox, FALSE, FALSE, 0);

	ibox = gtk_hbox_new(FALSE,3);
	label0 = gtk_label_new("TOT ICON");
	
	tot_icon_spin = gtk_spin_button_new_with_range(0,64,0.5);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(tot_icon_spin), ticon);
	gtk_spin_button_set_digits(GTK_SPIN_BUTTON(tot_icon_spin), 0.0);
	g_signal_connect(tot_icon_spin, "value-changed", G_CALLBACK(build_d_button), NULL);
	gtk_box_pack_start(GTK_BOX(ibox), label0, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(ibox), tot_icon_spin, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(mbox), ibox, FALSE, FALSE, 0);

	the_icon_box = gtk_hbox_new(FALSE,1);

	build_d_button();

	gtk_box_pack_start(GTK_BOX(mbox), the_icon_box, FALSE, FALSE, 0);
	
	ibox = gtk_hbox_new(FALSE,2);
	buttonS0 = gtk_button_new_from_stock(GTK_STOCK_APPLY); //("SAVE");
	gtk_box_pack_start(GTK_BOX(ibox), buttonS0, TRUE,TRUE, 0);
	gtk_box_pack_start(GTK_BOX(mbox), ibox, FALSE, FALSE, 0);
	g_signal_connect(buttonS0,"clicked",G_CALLBACK(save_icons_settings), NULL);
				
	gtk_container_add (GTK_CONTAINER (icon_frame), mbox);
	label1 = gtk_label_new("ICON SETTING");
	gtk_notebook_append_page (GTK_NOTEBOOK (notebook), icon_frame, label1);

	mbox2 = gtk_vbox_new(FALSE,2);
	lbox = gtk_hbox_new(TRUE,2);
	label0 = gtk_label_new ("Bold");
	
	bcheck = gtk_check_button_new ();
	if ( (!strcmp(weight,"bold")) ) { 
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(bcheck),TRUE);
	}
	gtk_box_pack_start(GTK_BOX(lbox), label0, FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(lbox), bcheck, FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(mbox2), lbox, FALSE, FALSE, 0);
	
	lbox = gtk_hbox_new(TRUE,2);
	label0 = gtk_label_new ("Italic");
	icheck = gtk_check_button_new ();
	if ( (!strcmp(style,"italic")) ) {
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(icheck), TRUE);
	}
	
	gtk_box_pack_start(GTK_BOX(lbox), label0, FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(lbox), icheck, FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(mbox2), lbox, FALSE, FALSE, 0);

	lbox = gtk_hbox_new(TRUE,2);
	label0 = gtk_label_new ("Color");
	GdkColor fg;
	gdk_color_parse(color, &fg);
	buttonC = hildon_color_button_new_with_color(&fg);
	gtk_box_pack_start(GTK_BOX(lbox), label0, FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(lbox), buttonC, FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(mbox2), lbox, FALSE, FALSE, 0);
	
	lbox = gtk_hbox_new(TRUE,2);
	
	label0 = gtk_label_new ("Font Size");
	ccbox = gtk_combo_box_new_text();
	for(i=0;font_size[i]!=NULL;i++) {
		gtk_combo_box_append_text(GTK_COMBO_BOX(ccbox), font_size[i]);
	}
	gtk_combo_box_append_text(GTK_COMBO_BOX(ccbox), fsize);
	gtk_combo_box_set_active(GTK_COMBO_BOX(ccbox),i);
	gtk_box_pack_start(GTK_BOX(lbox), label0, FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(lbox), ccbox, FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(mbox2), lbox, FALSE, FALSE, 0);

	lbox = gtk_hbox_new(TRUE,2);
	label0 = gtk_label_new("Visibilty");
	vbutt = gtk_check_button_new ();
	if ( visible == 1 ) {
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(vbutt), TRUE);
	}
	gtk_box_pack_start(GTK_BOX(lbox), label0, FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(lbox), vbutt, FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(mbox2), lbox, FALSE, FALSE, 0);

	lbox = gtk_hbox_new(TRUE,2);
	buttonS1 = gtk_button_new_from_stock(GTK_STOCK_APPLY); //gtk_button_new_with_label("SAVE");
	gtk_box_pack_start(GTK_BOX(lbox), buttonS1, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(mbox2), lbox, FALSE, FALSE, 0);
	g_signal_connect(buttonS1,"clicked",G_CALLBACK(save_label_settings), NULL);
				

	
	gtk_container_add(GTK_CONTAINER(label_frame), mbox2);
	label1 = gtk_label_new("LABEL SETTING");
	gtk_notebook_append_page (GTK_NOTEBOOK(notebook), label_frame, label1);
	
	
	mbox0 = gtk_vbox_new(FALSE,2);
	tbox = gtk_hbox_new(TRUE,2);
	label0 = gtk_label_new ("ICON PER ROWS");
	spin1 = gtk_spin_button_new_with_range(1,9,1);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(spin1),i_rows);
	gtk_box_pack_start(GTK_BOX(tbox), label0, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(tbox), spin1, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(mbox0), tbox, FALSE, FALSE, 0);

	tbox = gtk_hbox_new(TRUE,2);
	label0 = gtk_label_new("ROWS SPACING");
	spin2 = gtk_spin_button_new_with_range(0,99,1);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(spin2), row_spacing);
	gtk_box_pack_start(GTK_BOX(tbox), label0, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(tbox), spin2, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(mbox0), tbox, FALSE, FALSE, 0);

	tbox = gtk_hbox_new(TRUE,2);
	label0 = gtk_label_new("COLS SPACING");
	spin3 = gtk_spin_button_new_with_range(0,99,1);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(spin3), cell_spacing);
	gtk_box_pack_start(GTK_BOX(tbox), label0, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(tbox), spin3, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(mbox0), tbox, FALSE, FALSE, 0);

	tbox = gtk_hbox_new(TRUE,2);	
	buttonS2 = gtk_button_new_from_stock(GTK_STOCK_APPLY); //gtk_button_new_with_label("SAVE");
	gtk_box_pack_start(GTK_BOX(tbox), buttonS2, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(mbox0), tbox, FALSE, FALSE, 0);

	g_signal_connect(buttonS2,"clicked",G_CALLBACK(save_table_settings),NULL);
	
	gtk_container_add (GTK_CONTAINER (table_frame), mbox0);
	label1 = gtk_label_new("TABLE SETTING");
	gtk_notebook_append_page (GTK_NOTEBOOK (notebook), table_frame, label1);
	
	
	label0 = gtk_label_new("Double-Click on a row to change the association");

	table = gtk_table_new(3,1,FALSE);
	gtk_table_attach_defaults(GTK_TABLE(table), label0, 0,1,0,1);
	
	build_entry_list();
	
	button0 = gtk_button_new_from_stock(GTK_STOCK_REFRESH); //gtk_button_new_with_label("SAVE");
	gtk_widget_set_usize(GTK_WIDGET(button0), 500, 5);
	g_signal_connect(button0,"clicked",G_CALLBACK(refresh_value), NULL);
	gtk_table_attach_defaults(GTK_TABLE(table), button0, 0,1,2,3);
			
	
	gtk_container_add (GTK_CONTAINER (app_frame), table);
	label1 = gtk_label_new("APP SETTING");
	gtk_notebook_append_page (GTK_NOTEBOOK (notebook), app_frame, label1);

	gtk_notebook_set_page (GTK_NOTEBOOK(notebook), 1);
	
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox), notebook);
	
	
	gtk_widget_show_all(GTK_WIDGET(dialog));
	resp = gtk_dialog_run(GTK_DIALOG(dialog));
        if ( resp == GTK_RESPONSE_CANCEL ) {
		if ( smtg_written ) {
			idea_cp_quit();
		}
	}

	gtk_widget_destroy(GTK_WIDGET(dialog));
	
	return OSSO_OK;
}

osso_return_t save_state(osso_context_t *osso, gpointer data)
{
	/*save state*/
	return OSSO_OK;
}
